/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_BloodGasSaturation;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_BloodGasSaturation;


/**
 * This class represents BloodGasSaturation - CID3526
 */
public class BloodGasSaturation_CID3526 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new BloodGasSaturation_CID3526 Template 
	 */
	public BloodGasSaturation_CID3526()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumBloodGasSaturation Object of EnumCM_BloodGasSaturation represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_BloodGasSaturation enumBloodGasSaturation)
	{
		switch(enumBloodGasSaturation)
		{
		case BLOOD_CARBON_DIOXIDE_SATURATION: this.strCodeValue =EnumCV_BloodGasSaturation.BLOOD_CARBON_DIOXIDE_SATURATION_122187.getValue(); break;
		case BLOOD_OXYGEN_SATURATION: this.strCodeValue =EnumCV_BloodGasSaturation.BLOOD_OXYGEN_SATURATION_20564_1.getValue(); break;
		case ARTERIAL_OXYGEN_SATURATION: this.strCodeValue =EnumCV_BloodGasSaturation.ARTERIAL_OXYGEN_SATURATION_2708_6.getValue(); break;
		case VENOUS_OXYGEN_SATURATION: this.strCodeValue =EnumCV_BloodGasSaturation.VENOUS_OXYGEN_SATURATION_2711_0.getValue(); break;
		case CAPILLARY_BLOOD_OXYGEN_SATURATION: this.strCodeValue =EnumCV_BloodGasSaturation.CAPILLARY_BLOOD_OXYGEN_SATURATION_2709_4.getValue(); break;
		case CAPILLARYBLOODOXYGENSATURATION_BYOXIMETRY: this.strCodeValue =EnumCV_BloodGasSaturation.CAPILLARYBLOODOXYGENSATURATION_BYOXIMETRY_2710_2.getValue(); break;
		}
	}

	/**
	 * Sets the value for BloodGasSaturation
	 * @param enumBloodGasSaturation Object of EnumCM_BloodGasSaturation.
	 */
	public void setBloodGasSaturation(EnumCM_BloodGasSaturation enumBloodGasSaturation)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumBloodGasSaturation.getValue();
		if(enumBloodGasSaturation.getValue().equalsIgnoreCase(EnumCM_BloodGasSaturation.BLOOD_CARBON_DIOXIDE_SATURATION.getValue()))
		{
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		}
		else
		{
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.LN.getValue();
		}

		
		/**
		 * set code Value
		 */
		setCodeValue(enumBloodGasSaturation);
	}
}
